Index: LMDZ4/trunk/libf/phylmd/cpl_mod.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/cpl_mod.F90	(revision 993)
+++ LMDZ4/trunk/libf/phylmd/cpl_mod.F90	(revision 996)
@@ -32,6 +32,6 @@
   PRIVATE
 
-  ! All subroutine are public except cpl_send_all and cpl_receive_all
-  PUBLIC :: cpl_init, cpl_receive_ocean_fields, cpl_receive_seaice_fields, &
+  ! All subroutine are public except cpl_send_all
+  PUBLIC :: cpl_init, cpl_receive_frac, cpl_receive_ocean_fields, cpl_receive_seaice_fields, &
        cpl_send_ocean_fields, cpl_send_seaice_fields, cpl_send_land_fields, &
        cpl_send_landice_fields, gath2cpl
@@ -68,7 +68,4 @@
   !$OMP THREADPRIVATE(read_alb_sic)
   
-! fraction for different surface, saved during whole coupling period
-  REAL, ALLOCATABLE, DIMENSION(:,:), SAVE   :: pctsrf_sav   
-  !$OMP THREADPRIVATE(pctsrf_sav)
   INTEGER, ALLOCATABLE, DIMENSION(:), SAVE  :: unity
   !$OMP THREADPRIVATE(unity)
@@ -88,6 +85,5 @@
   !$OMP THREADPRIVATE(cpl_windsp2D)
   
-! variable for OPENMP parallelisation
-
+! variables for OPENMP parallelisation
   INTEGER,ALLOCATABLE,DIMENSION(:),SAVE :: knon_omp
   REAL,ALLOCATABLE,DIMENSION(:,:),SAVE ::  buffer_omp
@@ -146,6 +142,4 @@
     ALLOCATE(unity(klon), stat = error)
     sum_error = sum_error + error
-    ALLOCATE(pctsrf_sav(klon,nbsrf), stat = error)
-    sum_error = sum_error + error
     ALLOCATE(cpl_sols(klon,2), stat = error) 
     sum_error = sum_error + error
@@ -196,10 +190,9 @@
        unity(ig) = ig
     ENDDO
-    pctsrf_sav = 0.
-
-    cpl_sols = 0.   ; cpl_nsol = 0.  ; cpl_rain = 0.   ; cpl_snow = 0.
-    cpl_evap = 0.   ; cpl_tsol = 0.  ; cpl_fder = 0.   ; cpl_albe = 0.
-    cpl_taux = 0.   ; cpl_tauy = 0.  ; cpl_rriv2D = 0. ; cpl_rcoa2D = 0.
-    cpl_rlic2D = 0. ; cpl_windsp = 0.
+
+!    cpl_sols = 0.   ; cpl_nsol = 0.  ; cpl_rain = 0.   ; cpl_snow = 0.
+!    cpl_evap = 0.   ; cpl_tsol = 0.  ; cpl_fder = 0.   ; cpl_albe = 0.
+!    cpl_taux = 0.   ; cpl_tauy = 0.  ; cpl_rriv2D = 0. ; cpl_rcoa2D = 0.
+!    cpl_rlic2D = 0. ; cpl_windsp = 0.
 
 !*************************************************************************************
@@ -262,6 +255,6 @@
 
 !$OMP MASTER
-  ALLOCATE(knon_omp(0:omp_size-1)) 
-  ALLOCATE(buffer_omp(klon_mpi,0:omp_size-1))       
+    ALLOCATE(knon_omp(0:omp_size-1)) 
+    ALLOCATE(buffer_omp(klon_mpi,0:omp_size-1))       
 !$OMP END MASTER
 !$OMP BARRIER
@@ -272,8 +265,11 @@
 !*************************************************************************************
 !
-
-  SUBROUTINE cpl_receive_all(itime, dtime, pctsrf)
-! This subroutine reads from coupler for both ocean and seaice
+ 
+  SUBROUTINE cpl_receive_frac(itime, dtime, pctsrf, is_modified)
+! This subroutine receives from coupler for both ocean and seaice
 ! 4 fields : read_sst, read_sic, read_sit and read_alb_sic. 
+! The new sea-ice-land-landice fraction is returned. The others fields 
+! are stored in this module.
+    USE surface_data
 
     INCLUDE "indicesol.h"
@@ -283,20 +279,21 @@
     INCLUDE "dimensions.h"
 
-! Input arguments
+! Arguments
 !************************************************************************************
-    INTEGER, INTENT(IN)                     :: itime
-    REAL, INTENT(IN)                        :: dtime
-    REAL, DIMENSION(klon,nbsrf), INTENT(IN) :: pctsrf
+    INTEGER, INTENT(IN)                        :: itime
+    REAL, INTENT(IN)                           :: dtime
+    REAL, DIMENSION(klon,nbsrf), INTENT(INOUT) :: pctsrf
+    LOGICAL, INTENT(OUT)                       :: is_modified
 
 ! Local variables
 !************************************************************************************
-    INTEGER                                 :: j, ig, il_time_secs
+    INTEGER                                 :: j, i, time_sec
     INTEGER                                 :: itau_w
     INTEGER, DIMENSION(iim*(jjm+1))         :: ndexcs
-    CHARACTER(len = 20)                     :: modname = 'cpl_receive_all'
+    CHARACTER(len = 20)                     :: modname = 'cpl_receive_frac'
     CHARACTER(len = 80)                     :: abort_message
     REAL, DIMENSION(klon)                   :: read_sic1D
-    REAL, DIMENSION(iim,jj_nb,jpfldo2a)  :: tab_read_flds
-    REAL, DIMENSION(iim,jj_nb)           :: read_sic
+    REAL, DIMENSION(iim,jj_nb,jpfldo2a)     :: tab_read_flds
+    REAL, DIMENSION(klon,nbsrf)             :: pctsrf_old
 
 !*************************************************************************************
@@ -306,117 +303,72 @@
 !*************************************************************************************
 
+    is_modified=.FALSE.
+
+! Check if right moment to recevie from coupler
+    IF (MOD(itime, nexca) == 1) THEN
+       is_modified=.TRUE.
+ 
+       time_sec=(itime-1)*dtime
 #ifdef CPP_COUPLE
-    il_time_secs=(itime-1)*dtime
 !$OMP MASTER
-    CALL fromcpl(il_time_secs, tab_read_flds)
+       CALL fromcpl(time_sec, tab_read_flds)
 !$OMP END MASTER
 #endif
     
 ! NetCDF output of received fields
-    IF (is_sequential) THEN
-       ndexcs(:) = 0
-       itau_w = itau_phy + itime
-       DO ig = 1, jpfldo2a
-          CALL histwrite(nidcs,cl_read(ig),itau_w,tab_read_flds(:,:,ig),iim*(jjm+1),ndexcs)
-       END DO
-    ENDIF
-
+       IF (is_sequential) THEN
+          ndexcs(:) = 0
+          itau_w = itau_phy + itime
+          DO i = 1, jpfldo2a
+             CALL histwrite(nidcs,cl_read(i),itau_w,tab_read_flds(:,:,i),iim*(jjm+1),ndexcs)
+          END DO
+       ENDIF
+
+! Save each field in a 2D array. 
 !$OMP MASTER
-
-! Save each field in a 2D array. 
-
-    IF (OPA_version=='OPA9') THEN
-      read_sst(:,:)     = tab_read_flds(:,:,1)  ! Sea surface temperature
-      read_sic(:,:)     = tab_read_flds(:,:,2)  ! Sea ice concentration
-      read_sit(:,:)     = tab_read_flds(:,:,3)  ! Sea ice temperature
-      read_alb_sic(:,:) = tab_read_flds(:,:,4)  ! Albedo at sea ice
-    ELSE IF (OPA_version=='OPA8') THEN
-      read_sst(:,:)     = tab_read_flds(:,:,1)  ! Sea surface temperature
-      read_sic(:,:)     = tab_read_flds(:,:,2)  ! Sea ice concentration
-      read_alb_sic(:,:) = tab_read_flds(:,:,3)  ! Albedo at sea ice
-      read_sit(:,:)     = tab_read_flds(:,:,4)  ! Sea ice temperature
-    ELSE
-      STOP 'Bad OPA version for coupled model'
-    ENDIF
-
-!*************************************************************************************
-! Temperature and albedo are weighted with the fraction of sea-ice(read-sic)
-!
-!*************************************************************************************
-    DO j = 1, jj_nb
-       DO ig = 1, iim
-          IF (ABS(1. - read_sic(ig,j)) < 0.00001) THEN
-             read_sst(ig,j) = RTT - 1.8
-             read_sit(ig,j) = read_sit(ig,j) / read_sic(ig,j)
-             read_alb_sic(ig,j) = read_alb_sic(ig,j) / read_sic(ig,j)
-          ELSE IF (ABS(read_sic(ig,j)) < 0.00001) THEN
-             read_sst(ig,j) = read_sst(ig,j) / (1. - read_sic(ig,j))
-             read_sit(ig,j) = read_sst(ig,j)
-             read_alb_sic(ig,j) =  0.6
-          ELSE
-             read_sst(ig,j) = read_sst(ig,j) / (1. - read_sic(ig,j))
-             read_sit(ig,j) = read_sit(ig,j) / read_sic(ig,j)
-             read_alb_sic(ig,j) = read_alb_sic(ig,j) / read_sic(ig,j)
+       IF (version_ocean=='nemo') THEN
+          read_sst(:,:)     = tab_read_flds(:,:,1)  ! Sea surface temperature
+          read_sic(:,:)     = tab_read_flds(:,:,2)  ! Sea ice concentration
+          read_sit(:,:)     = tab_read_flds(:,:,3)  ! Sea ice temperature
+          read_alb_sic(:,:) = tab_read_flds(:,:,4)  ! Albedo at sea ice
+       ELSE IF (version_ocean=='opa8') THEN
+          read_sst(:,:)     = tab_read_flds(:,:,1)  ! Sea surface temperature (multiplicated by fraction)
+          read_sic(:,:)     = tab_read_flds(:,:,2)  ! Sea ice concentration 
+          read_alb_sic(:,:) = tab_read_flds(:,:,3)  ! Albedo at sea ice (multiplicated by fraction)
+          read_sit(:,:)     = tab_read_flds(:,:,4)  ! Sea ice temperature (multiplicated by fraction)
+       END IF
+!$OMP END MASTER
+
+!*************************************************************************************
+!  Transform seaice fraction (read_sic : ocean-seaice mask) into global 
+!  fraction (pctsrf : ocean-seaice-land-landice mask)
+!
+!*************************************************************************************
+       CALL cpl2gath(read_sic, read_sic1D, klon, unity)
+
+       pctsrf_old(:,:) = pctsrf(:,:)
+       DO i = 1, klon
+          ! treatment only of points with ocean and/or seaice
+          IF (pctsrf_old(i,is_oce) + pctsrf_old(i,is_sic) > 0.) THEN
+             pctsrf(i,is_sic) = (pctsrf_old(i,is_oce) + pctsrf_old(i,is_sic)) &
+                  * read_sic1D(i)
+             pctsrf(i,is_oce) = (pctsrf_old(i,is_oce) + pctsrf_old(i,is_sic)) &
+                  - pctsrf(i,is_sic)
           ENDIF
        ENDDO
-    ENDDO
-!$OMP END MASTER
-
-!*************************************************************************************
-!  Transform seaice fraction, read_sic into pctsrf_sav
-!
-!*************************************************************************************
-    CALL cpl2gath(read_sic, read_sic1D, klon, unity)
-
-    DO ig = 1, klon
-       ! treatment only of ocean and/or seaice points
-       IF (pctsrf(ig,is_oce) > epsfra .OR. &
-            pctsrf(ig,is_sic) > epsfra) THEN
-          pctsrf_sav(ig,is_sic) = (pctsrf(ig,is_oce) + pctsrf(ig,is_sic)) &
-               * read_sic1D(ig)
-          pctsrf_sav(ig,is_oce) = (pctsrf(ig,is_oce) + pctsrf(ig,is_sic)) &
-               - pctsrf_sav(ig,is_sic)
-       ENDIF
-    ENDDO
-
-!*************************************************************************************
-! To avoid round up problems
-!
-!*************************************************************************************
-    WHERE (ABS(pctsrf_sav(:,is_sic)) .LE. 2.*EPSILON(pctsrf_sav(1,is_sic)))
-       pctsrf_sav(:,is_sic) = 0.
-       pctsrf_sav(:,is_oce) = pctsrf(:,is_oce) + pctsrf(:,is_sic)
-    ENDWHERE
-    WHERE (ABS(pctsrf_sav(:,is_oce)) .LE. 2.*EPSILON(pctsrf_sav(1,is_oce)))
-       pctsrf_sav(:,is_sic) = pctsrf(:,is_oce) + pctsrf(:,is_sic)
-       pctsrf_sav(:,is_oce) = 0.
-    ENDWHERE
-    IF (MINVAL(pctsrf_sav(:,is_oce)) < 0.) THEN
-       WRITE(*,*)'Pb fraction ocean inferieure a 0'
-       WRITE(*,*)'au point ',MINLOC(pctsrf_sav(:,is_oce))
-       WRITE(*,*)'valeur = ',MINVAL(pctsrf_sav(:,is_oce)) 
-       abort_message = 'voir ci-dessus'
-       CALL abort_gcm(modname,abort_message,1)
-    ENDIF
-    IF (MINVAL(pctsrf_sav(:,is_sic)) < 0.) THEN
-       WRITE(*,*)'Pb fraction glace inferieure a 0'
-       WRITE(*,*)'au point ',MINLOC(pctsrf_sav(:,is_sic))
-       WRITE(*,*)'valeur = ',MINVAL(pctsrf_sav(:,is_sic)) 
-       abort_message = 'voir ci-dessus'
-       CALL abort_gcm(modname,abort_message,1)
-    ENDIF
-        
-  END SUBROUTINE cpl_receive_all
-!
-!*************************************************************************************
-! 
-  SUBROUTINE cpl_receive_ocean_fields(itime, dtime, knon, knindex, pctsrf, &
-       tsurf_new, pctsrf_oce)
-!
-! This routine reads, if first time step in a coupling period, all fields reveived from
-! coupler for all types of surfaces. It returns the fields for the ocean surface which
-! are the sea surface temperature and the fraction of ocean. 
-! The fields are transformed into 1D arrays with valid points : 
-! tsurf_new(1:knon), pctsrf(1:klon).
+
+    END IF ! if time to receive
+
+  END SUBROUTINE cpl_receive_frac
+
+!
+!*************************************************************************************
+!
+
+  SUBROUTINE cpl_receive_ocean_fields(knon, knindex, tsurf_new)
+!
+! This routine returns the field for the ocean that has been read from the coupler
+! (done earlier with cpl_receive_frac). The field is the temperature.
+! The temperature is transformed into 1D array with valid points from index 1 to knon.
 !
     INCLUDE "indicesol.h"
@@ -424,23 +376,15 @@
 ! Input arguments
 !*************************************************************************************
-    INTEGER, INTENT(IN)                     :: itime
-    REAL, INTENT(IN)                        :: dtime
     INTEGER, INTENT(IN)                     :: knon
     INTEGER, DIMENSION(klon), INTENT(IN)    :: knindex
-    REAL, DIMENSION(klon,nbsrf), INTENT(IN) :: pctsrf
 
 ! Output arguments
 !*************************************************************************************
     REAL, DIMENSION(klon), INTENT(OUT)      :: tsurf_new
-    REAL, DIMENSION(klon), INTENT(OUT)      :: pctsrf_oce
-
-!*************************************************************************************
-! If first time step in a coupling period receive all fields for all types
-! of surfaces from coupler : read_sst, read_sit, read_alb_sic and pctsrf_sav. 
-! 
-!*************************************************************************************
-
-    IF (MOD(itime, nexca) == 1) CALL cpl_receive_all(itime, dtime, pctsrf)
-
+
+! Local variables
+!*************************************************************************************
+    INTEGER               :: i
+    REAL, DIMENSION(klon) :: sic_new
 
 !*************************************************************************************
@@ -449,21 +393,29 @@
 !*************************************************************************************
     CALL cpl2gath(read_sst, tsurf_new, knon, knindex)
-    pctsrf_oce(:) = pctsrf_sav(:,is_oce) 
-
+    CALL cpl2gath(read_sic, sic_new, knon, knindex)
+
+!*************************************************************************************
+! The fields received from the coupler have to be weighted with the fraction of ocean 
+! in relation to the total sea-ice+ocean
+!
+!*************************************************************************************
+    DO i=1, knon
+       tsurf_new(i) = tsurf_new(i)/(1. - sic_new(i))
+    END DO
 
   END SUBROUTINE cpl_receive_ocean_fields
-!
-!*************************************************************************************
-!
+
+!
+!*************************************************************************************
+!
+
   SUBROUTINE cpl_receive_seaice_fields(knon, knindex, &
-       tsurf_new, alb_new, pctsrf_sic)
+       tsurf_new, alb_new)
 !
 ! This routine returns the fields for the seaice that have been read from the coupler
-! (done earlier with cpl_receive_ocean_fields). These fields are the temperature and 
+! (done earlier with cpl_receive_frac). These fields are the temperature and 
 ! albedo at sea ice surface and fraction of sea ice.
-! The fields are transformed into  1D arrays with valid points : 
-! tsurf_new(1:knon), alb_new(1:knon), pctsrf(1:klon).
-!
-    INCLUDE "indicesol.h"
+! The fields are transformed into 1D arrays with valid points from index 1 to knon. 
+!
 
 ! Input arguments
@@ -476,6 +428,9 @@
     REAL, DIMENSION(klon), INTENT(OUT)      :: tsurf_new
     REAL, DIMENSION(klon), INTENT(OUT)      :: alb_new
-    REAL, DIMENSION(klon), INTENT(OUT)      :: pctsrf_sic
-
+
+! Local variables
+!*************************************************************************************
+    INTEGER               :: i
+    REAL, DIMENSION(klon) :: sic_new
 
 !*************************************************************************************
@@ -485,5 +440,15 @@
     CALL cpl2gath(read_sit, tsurf_new, knon, knindex)
     CALL cpl2gath(read_alb_sic, alb_new, knon, knindex)
-    pctsrf_sic(:) = pctsrf_sav(:,is_sic) 
+    CALL cpl2gath(read_sic, sic_new, knon, knindex)
+
+!*************************************************************************************
+! The fields received from the coupler have to be weighted with the sea-ice 
+! concentration (in relation to the total sea-ice + ocean).
+!
+!*************************************************************************************
+    DO i= 1, knon
+       tsurf_new(i) = tsurf_new(i) / sic_new(i)
+       alb_new(i)   = alb_new(i)   / sic_new(i)
+    END DO
 
   END SUBROUTINE cpl_receive_seaice_fields
@@ -535,15 +500,15 @@
 !*************************************************************************************
     IF (MOD(itime, nexca) == 1) THEN
-       cpl_sols(:,cpl_index) = 0.0
-       cpl_nsol(:,cpl_index) = 0.0
-       cpl_rain(:,cpl_index) = 0.0
-       cpl_snow(:,cpl_index) = 0.0
-       cpl_evap(:,cpl_index) = 0.0
-       cpl_tsol(:,cpl_index) = 0.0
-       cpl_fder(:,cpl_index) = 0.0
-       cpl_albe(:,cpl_index) = 0.0
-       cpl_taux(:,cpl_index) = 0.0
-       cpl_tauy(:,cpl_index) = 0.0
-       cpl_windsp(:,cpl_index) = 0.0
+       cpl_sols(1:knon,cpl_index) = 0.0
+       cpl_nsol(1:knon,cpl_index) = 0.0
+       cpl_rain(1:knon,cpl_index) = 0.0
+       cpl_snow(1:knon,cpl_index) = 0.0
+       cpl_evap(1:knon,cpl_index) = 0.0
+       cpl_tsol(1:knon,cpl_index) = 0.0
+       cpl_fder(1:knon,cpl_index) = 0.0
+       cpl_albe(1:knon,cpl_index) = 0.0
+       cpl_taux(1:knon,cpl_index) = 0.0
+       cpl_tauy(1:knon,cpl_index) = 0.0
+       cpl_windsp(1:knon,cpl_index) = 0.0
     ENDIF
        
@@ -709,14 +674,14 @@
 !*************************************************************************************
     IF (MOD(itime, nexca) == 1) THEN
-       cpl_sols(:,cpl_index) = 0.0
-       cpl_nsol(:,cpl_index) = 0.0
-       cpl_rain(:,cpl_index) = 0.0
-       cpl_snow(:,cpl_index) = 0.0
-       cpl_evap(:,cpl_index) = 0.0
-       cpl_tsol(:,cpl_index) = 0.0
-       cpl_fder(:,cpl_index) = 0.0
-       cpl_albe(:,cpl_index) = 0.0
-       cpl_taux(:,cpl_index) = 0.0
-       cpl_tauy(:,cpl_index) = 0.0
+       cpl_sols(1:knon,cpl_index) = 0.0
+       cpl_nsol(1:knon,cpl_index) = 0.0
+       cpl_rain(1:knon,cpl_index) = 0.0
+       cpl_snow(1:knon,cpl_index) = 0.0
+       cpl_evap(1:knon,cpl_index) = 0.0
+       cpl_tsol(1:knon,cpl_index) = 0.0
+       cpl_fder(1:knon,cpl_index) = 0.0
+       cpl_albe(1:knon,cpl_index) = 0.0
+       cpl_taux(1:knon,cpl_index) = 0.0
+       cpl_tauy(1:knon,cpl_index) = 0.0
     ENDIF
        
@@ -893,5 +858,5 @@
 !
     INCLUDE "dimensions.h"
-    
+
 ! Input varibales
 !*************************************************************************************
@@ -944,4 +909,5 @@
 ! all calculations at the different surfaces have to be done before. 
 !    
+    USE surface_data
 ! Some includes
 !*************************************************************************************
@@ -962,5 +928,5 @@
     INTEGER                                              :: error, sum_error, j
     INTEGER                                              :: itau_w
-    INTEGER                                              :: il_time_secs
+    INTEGER                                              :: time_sec
     INTEGER, DIMENSION(iim*(jjm+1))                      :: ndexct
     REAL                                                 :: Up, Down
@@ -994,32 +960,28 @@
 !
 !*************************************************************************************
-!! AC >>
-
 !$OMP MASTER
-    IF (OPA_version=='OPA9') THEN
-      tab_flds(:,:,7)  = cpl_windsp2D(:,:)
-      tab_flds(:,:,14) = cpl_sols2D(:,:,2)
-      tab_flds(:,:,12) = cpl_sols2D(:,:,1)
-      tab_flds(:,:,15) = cpl_nsol2D(:,:,2)
-      tab_flds(:,:,13) = cpl_nsol2D(:,:,1)
-      tab_flds(:,:,16) = cpl_fder2D(:,:,2)
-      tab_flds(:,:,11) = cpl_evap2D(:,:,2)
-      tab_flds(:,:,18) = cpl_rriv2D(:,:)
-      tab_flds(:,:,19) = cpl_rcoa2D(:,:)
-    ELSE IF (OPA_version=='OPA8') THEN
-      tab_flds(:,:,7)  = cpl_windsp2D(:,:)
-      tab_flds(:,:,8)  = cpl_sols2D(:,:,2)
-      tab_flds(:,:,9)  = cpl_sols2D(:,:,1)
-      tab_flds(:,:,10) = cpl_nsol2D(:,:,2)
-      tab_flds(:,:,11) = cpl_nsol2D(:,:,1)
-      tab_flds(:,:,12) = cpl_fder2D(:,:,2)
-      tab_flds(:,:,13) = cpl_evap2D(:,:,2)
-      tab_flds(:,:,14) = cpl_evap2D(:,:,1)
-      tab_flds(:,:,17) = cpl_rcoa2D(:,:)
-      tab_flds(:,:,18) = cpl_rriv2D(:,:)
-    ELSE
-      STOP 'Bad OPA version for coupled model'
-    ENDIF
-
+    IF (version_ocean=='nemo') THEN
+       tab_flds(:,:,7)  = cpl_windsp2D(:,:)
+       tab_flds(:,:,14) = cpl_sols2D(:,:,2)
+       tab_flds(:,:,12) = cpl_sols2D(:,:,1)
+       tab_flds(:,:,15) = cpl_nsol2D(:,:,2)
+       tab_flds(:,:,13) = cpl_nsol2D(:,:,1)
+       tab_flds(:,:,16) = cpl_fder2D(:,:,2)
+       tab_flds(:,:,11) = cpl_evap2D(:,:,2)
+       tab_flds(:,:,18) = cpl_rriv2D(:,:)
+       tab_flds(:,:,19) = cpl_rcoa2D(:,:)
+    ELSE IF (version_ocean=='opa8') THEN
+       tab_flds(:,:,7)  = cpl_windsp2D(:,:)
+       tab_flds(:,:,8)  = cpl_sols2D(:,:,2)
+       tab_flds(:,:,9)  = cpl_sols2D(:,:,1)
+       tab_flds(:,:,10) = cpl_nsol2D(:,:,2)
+       tab_flds(:,:,11) = cpl_nsol2D(:,:,1)
+       tab_flds(:,:,12) = cpl_fder2D(:,:,2)
+       tab_flds(:,:,13) = cpl_evap2D(:,:,2)
+       tab_flds(:,:,14) = cpl_evap2D(:,:,1)
+       tab_flds(:,:,17) = cpl_rcoa2D(:,:)
+       tab_flds(:,:,18) = cpl_rriv2D(:,:)
+    END IF
+    
 !*************************************************************************************
 ! Transform the fraction of sub-surfaces from 1D to 2D array
@@ -1028,5 +990,4 @@
     pctsrf2D(:,:,:) = 0.
 !$OMP END MASTER
-
     CALL gath2cpl(pctsrf(:,is_oce), pctsrf2D(:,:,is_oce), klon, unity)
     CALL gath2cpl(pctsrf(:,is_sic), pctsrf2D(:,:,is_sic), klon, unity)
@@ -1040,11 +1001,11 @@
     IF (is_omp_root) THEN
 
-      DO j = 1, jj_nb
-         tmp_calv(:,j) = DOT_PRODUCT (cpl_rlic2D(1:iim,j), &
-              pctsrf2D(1:iim,j,is_lic)) / REAL(iim)
-      ENDDO
-    
-    
-      IF (is_parallel) THEN
+       DO j = 1, jj_nb
+          tmp_calv(:,j) = DOT_PRODUCT (cpl_rlic2D(1:iim,j), &
+               pctsrf2D(1:iim,j,is_lic)) / REAL(iim)
+       ENDDO
+       
+    
+       IF (is_parallel) THEN
          IF (.NOT. is_north_pole) THEN
 #ifdef CPP_PARA
@@ -1053,5 +1014,5 @@
 #endif
          ENDIF
-       
+          
          IF (.NOT. is_south_pole) THEN
 #ifdef CPP_PARA
@@ -1060,10 +1021,10 @@
 #endif
          ENDIF
-       
+         
          IF (.NOT. is_north_pole .AND. ii_begin /=1) THEN
             Up=Up+tmp_calv(iim,1)
             tmp_calv(:,1)=Up
          ENDIF
-       
+         
          IF (.NOT. is_south_pole .AND. ii_end /= iim) THEN
             Down=Down+tmp_calv(1,jj_nb)
@@ -1071,13 +1032,10 @@
          ENDIF
       ENDIF
-        
-      IF (OPA_version=='OPA9') THEN
-        tab_flds(:,:,17) = tmp_calv(:,:)
-      ELSE IF (OPA_version=='OPA8') THEN
-        tab_flds(:,:,17) = tmp_calv(:,:)
-      ELSE
-        STOP 'Bad OPA version for coupled model'
-      ENDIF
-
+      
+      IF (version_ocean=='nemo') THEN
+         tab_flds(:,:,17) = tmp_calv(:,:)
+      ELSE IF (version_ocean=='opa8') THEN
+         tab_flds(:,:,19) = tmp_calv(:,:)
+      END IF
 
 !*************************************************************************************
@@ -1089,53 +1047,45 @@
 !
 !*************************************************************************************    
-      ! fraction oce+seaice
-      deno =  pctsrf2D(:,:,is_oce) + pctsrf2D(:,:,is_sic) 
-
-      IF (OPA_version=='OPA9') THEN
-
-        tab_flds(:,:,10) = 0.0
-        tmp_taux(:,:)    = 0.0
-        tmp_tauy(:,:)    = 0.0
-        ! fraction oce+seaice
-        ! For all valid grid cells containing some fraction of ocean or sea-ice
-        WHERE ( deno(:,:) /= 0 )
-           tab_flds(:,:,10) = cpl_snow2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
-                              cpl_snow2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
-
-           tmp_taux = cpl_taux2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
-                      cpl_taux2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
-           tmp_tauy = cpl_tauy2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
-                      cpl_tauy2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
-        ENDWHERE
-        tab_flds(:,:,8) = (cpl_evap2D(:,:,1) - ( cpl_rain2D(:,:,1) + cpl_snow2D(:,:,1)))
-        tab_flds(:,:,9) = (cpl_evap2D(:,:,2) - ( cpl_rain2D(:,:,2) + cpl_snow2D(:,:,2)))
-
-      ELSE IF (OPA_version=='OPA8') THEN
-
-        tab_flds(:,:,15) = 0.0
-        tab_flds(:,:,16) = 0.0
-        tmp_taux(:,:)    = 0.0
-        tmp_tauy(:,:)    = 0.0
-        ! For all valid grid cells containing some fraction of ocean or sea-ice
-        WHERE ( deno(:,:) /= 0 )
-           tab_flds(:,:,15) = cpl_rain2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
-                              cpl_rain2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
-           tab_flds(:,:,16) = cpl_snow2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
-                              cpl_snow2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
-       
-           tmp_taux = cpl_taux2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
-                      cpl_taux2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
-           tmp_tauy = cpl_tauy2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
-                      cpl_tauy2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
-        ENDWHERE
-
-      ELSE
-        STOP 'Bad OPA version for coupled model'
-      ENDIF
-    
-    ENDIF ! is_omp_root  
-
-
-! AC <<
+       ! fraction oce+seaice
+       deno =  pctsrf2D(:,:,is_oce) + pctsrf2D(:,:,is_sic) 
+
+       IF (version_ocean=='nemo') THEN
+          tab_flds(:,:,10) = 0.0
+          tmp_taux(:,:)    = 0.0
+          tmp_tauy(:,:)    = 0.0
+          ! For all valid grid cells containing some fraction of ocean or sea-ice
+          WHERE ( deno(:,:) /= 0 )
+             tab_flds(:,:,10) = cpl_snow2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
+                  cpl_snow2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
+             
+             tmp_taux = cpl_taux2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
+                  cpl_taux2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
+             tmp_tauy = cpl_tauy2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
+                  cpl_tauy2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
+          ENDWHERE
+          tab_flds(:,:,8) = (cpl_evap2D(:,:,1) - ( cpl_rain2D(:,:,1) + cpl_snow2D(:,:,1)))
+          tab_flds(:,:,9) = (cpl_evap2D(:,:,2) - ( cpl_rain2D(:,:,2) + cpl_snow2D(:,:,2)))
+          
+       ELSE IF (version_ocean=='opa8') THEN
+          tab_flds(:,:,15) = 0.0
+          tab_flds(:,:,16) = 0.0
+          tmp_taux(:,:)    = 0.0
+          tmp_tauy(:,:)    = 0.0
+          ! For all valid grid cells containing some fraction of ocean or sea-ice
+          WHERE ( deno(:,:) /= 0 )
+             tab_flds(:,:,15) = cpl_rain2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
+                  cpl_rain2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
+             tab_flds(:,:,16) = cpl_snow2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
+                  cpl_snow2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
+             
+             tmp_taux = cpl_taux2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
+                  cpl_taux2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
+             tmp_tauy = cpl_tauy2D(:,:,1) * pctsrf2D(:,:,is_oce) / deno(:,:) +    &
+                  cpl_tauy2D(:,:,2) * pctsrf2D(:,:,is_sic) / deno(:,:)
+          ENDWHERE
+       END IF
+
+    ENDIF ! is_omp_root
+  
 !*************************************************************************************
 ! Transform the wind components from local atmospheric 2D coordinates to geocentric 
@@ -1145,5 +1095,4 @@
 
 ! Transform the longitudes and latitudes on 2D arrays
-    
     CALL gather_omp(rlon,rlon_mpi)
     CALL gather_omp(rlat,rlat_mpi)
@@ -1211,8 +1160,8 @@
 !
 !*************************************************************************************
+    time_sec=(itime-1)*dtime
 #ifdef CPP_COUPLE
-    il_time_secs=(itime-1)*dtime
 !$OMP MASTER
-    CALL intocpl(il_time_secs, lafin, tab_flds(:,:,:))
+    CALL intocpl(time_sec, lafin, tab_flds(:,:,:))
 !$OMP END MASTER
 #endif
@@ -1239,5 +1188,5 @@
 !
   SUBROUTINE cpl2gath(champ_in, champ_out, knon, knindex)
-  USE mod_phys_lmdz_para
+    USE mod_phys_lmdz_para
 ! Cette routine ecrit un champ 'gathered' sur la grille 2D pour le passer
 ! au coupleur.
@@ -1269,6 +1218,4 @@
 !*************************************************************************************
 !
-    
-
 ! Transform from 2 dimensions (iim,jj_nb) to 1 dimension (klon)
 !$OMP MASTER 
@@ -1283,5 +1230,4 @@
        champ_out(i) = temp_omp(ig)
     ENDDO
-  
    
   END SUBROUTINE cpl2gath
Index: LMDZ4/trunk/libf/phylmd/ini_paramLMDZ_phy.h
===================================================================
--- LMDZ4/trunk/libf/phylmd/ini_paramLMDZ_phy.h	(revision 993)
+++ LMDZ4/trunk/libf/phylmd/ini_paramLMDZ_phy.h	(revision 996)
@@ -31,10 +31,4 @@
      .                "once", zstophy,zout)
 c
-       CALL histdef(nid_ctesGCM, "ok_slab_sicOBS",
-     ."ok_slab_sicOBS= 1: glace de mer observee, =0: gl.mer calculee 
-     . par le slab", "-",
-     .                iim,jjmp1,nhori, 1,1,1, -99, 32,
-     .                "once", zstophy,zout)
-c
        CALL histdef(nid_ctesGCM, "type_run",
      .        "Type run: 1= CLIM ou ENSP, 2= AMIP ou CFMI",
